/*
 *Check to see if boolean_current_content_type module variable is true. It's an array of selected content types in the module settings
 * If so, load all paragraph tags into an array. Loop through paragraphs array and append a Div below each. Div will include the clickable
 * image to expand Div to see comments and link to add comments. Hide each div to start. Add a handler for each div.
 * Note, each element contains the paragraphID from the database.
 */
jQuery(document).ready(function () {

    //Variable passed from paragraph_comments.module specifying if current content type is select in admin for paragraph comments
    if (Drupal.settings.paragraph_comments.boolean_current_content_type == true && Drupal.settings.paragraph_comments.paragraph_comments_permissions == true) {
        //Put each <p> element in an array
        var paragraph_array = jQuery(".field-name-body p");

	//remove p elements without pid.  This happens when drupal sticks in extra p tags at beginning and end after a node is saved
	for (i = 0; i < paragraph_array.length; i++) {
		if (jQuery(paragraph_array[i]).text() == "") {
			paragraph_array.splice(i, 1);
		}	
	}


        //Drupal.settings.paragraph_comments.paragraph_comment_text[i].pid is an array that's filled on hook_node_view and hook_node_presave in paragraph_comments.module
        //Loops through paragraphs, finds the paragraphcommentsid in the html, adds a random id to any that don't already have it, then fills this Drupal.settings array.
        //We will loop through this array adding addition elements in the jquery and assign them the matching paragraphid.
        //Note we now have the id of the image and link as just the number from paragraphcommentsid. The others have a prefix. This will make it easier to specify
        //the div to hold the comment in the click function without using string functions.
        for (i = 0; i < paragraph_array.length; i++) {

          //console.log(document.getElementById(Drupal.settings.paragraph_comments.paragraph_comment_text[i].pid));

           // Temporary variable holding the element containing the paragraph text.
            var temp = document.getElementById(Drupal.settings.paragraph_comments.paragraph_comment_text[i].pid);
            var temp_text = temp.textContent;
                //escape forward slash, we'll put them back in paragraph_comments_form_comment_form_alter
            var temp_text = temp_text.replace(/\//g, "esc_forward_slash");
                //escape question mark
            var temp_text = temp_text.replace(/\?/g, "esc_question_mark");


            //Paragraph Commment Count
            //var strParagraphID = Drupal.settings.paragraph_comments.paragraph_comment_text[i].pid;
            jQuery(paragraph_array[i]).append('<div class="paragraph-comments-buttons"><div class="paragraph-comments-count" id = "commentCount' + Drupal.settings.paragraph_comments.paragraph_comment_text[i].pid + '" id="commentCount' + Drupal.settings.paragraph_comments.paragraph_comment_text[i].pid + '"></div><div id="hide-show" class="paragraph-comments-show"><a href="#' + Drupal.settings.paragraph_comments.paragraph_comment_text[i].pid + '"><img id="image' + Drupal.settings.paragraph_comments.paragraph_comment_text[i].pid + '" src="' + Drupal.settings.paragraph_comments.base_url + '/' + Drupal.settings.paragraph_comments.path + '/images/view_comment.png" border="0" alt="View comments"></a></div><div id="hide-show" class="paragraph-comments-add-comment-perfect"><a id="addCommentPerfect' + Drupal.settings.paragraph_comments.paragraph_comment_text[i].pid + '" href="' + Drupal.settings.paragraph_comments.base_url + '/paragraph_comments_perfect_form/' + Drupal.settings.paragraph_comments.nid + '/' + Drupal.settings.paragraph_comments.paragraph_comment_text[i].pid + '/' + Drupal.settings.paragraph_comments.current_content_type + '/' + temp_text + '" ><img src="' + Drupal.settings.paragraph_comments.base_url + '/' + Drupal.settings.paragraph_comments.path + '/images/submit_perfect.png" border="0" alt="Add paragraph comment"></a></div><div id="hide-show" class="paragraph-comments-add-comment"><a id="addComment' + Drupal.settings.paragraph_comments.paragraph_comment_text[i].pid + '" href="' + Drupal.settings.paragraph_comments.base_url + '/paragraph_comments_comment_form/' + Drupal.settings.paragraph_comments.nid + '/' + Drupal.settings.paragraph_comments.paragraph_comment_text[i].pid + '/' + Drupal.settings.paragraph_comments.current_content_type + '/' + temp_text + '" ><img src="' + Drupal.settings.paragraph_comments.base_url + '/' + Drupal.settings.paragraph_comments.path + '/images/submit_comment.png" border="0" alt="Add paragraph comment"></a></div></div></div>');



            //Expandable Div that holds comments 
            jQuery(paragraph_array[i]).append('<div class="slidingDiv" id="slidingDiv' + Drupal.settings.paragraph_comments.paragraph_comment_text[i].pid + '"> </div>');


        }

        //Loop through each paragraph, hide the sliding Div on load or refresh
        for (i = 0; i < paragraph_array.length; i++) {
            jQuery('#slidingDiv' + Drupal.settings.paragraph_comments.paragraph_comment_text[i].pid).hide();
        }

        //Loop through and assign functions to elements. The image to expand the div has a click event. Note, we're looking for elements with the id (# in jquery) that has only the number 
        //from paragraphcommentsid. Only the image link that expands and contracts the div doesn't have a prefix on the id. For the comment count, we're assigning the click event to the div, then
        //triggering it. coudn't use 'ready' since the element is the document, so not able to retrieve paragraphID
        for (i = 0; i < paragraph_array.length; i++) {
            jQuery('#image' + Drupal.settings.paragraph_comments.paragraph_comment_text[i].pid).click({
                div: 'slidingDiv' + Drupal.settings.paragraph_comments.paragraph_comment_text[i].pid
            }, handleClick);
            jQuery('#commentCount' + Drupal.settings.paragraph_comments.paragraph_comment_text[i].pid).click({
                div: 'commentCount' + Drupal.settings.paragraph_comments.paragraph_comment_text[i].pid
            }, countReady);
            jQuery('#commentCount' + Drupal.settings.paragraph_comments.paragraph_comment_text[i].pid).trigger("click");
        }
        //end if statement
    }


    //here is the event launched from handler for each paragraph link. The div is the parameter that contains the div id that we can hide and show
    function handleClick(event) {
        var strID = event.target.id;
        strID = event.target.id.replace("image", "");
        jQuery('#slidingDiv' + strID).slideToggle();
        //see if the slidingDiv has any text. If so, trim function should be greater than 1. No need to run select query for comments again.
        if (jQuery("#slidingDiv" + strID).text().trim().length == 0) {
            //If doesn't already have comment text in Div, we'll call this function via callback url below: paragraph_comments_get_comments($paragraphcommentid)
            jQuery.get(Drupal.settings.paragraph_comments.base_url + "/paragraph_comments_get_comments/" + strID,
                function (data) {
                    //The id of image(the target) is the paragraphcomments id. By adding the prefex slidingDiv we can specify the Div that should contain the corresponding comments
                    //Take data returned from function above and append paragraph with comment
                    jQuery("#slidingDiv" + strID).append("<p>" + data + " </p>")
                }, "json");
        }
        return false;
    }


    function countReady(event) {
        //for the comment count the ID is commentCount + the id, so we strip "commentCount" before sending it to the paragraph_comments_get_comment_count function
        //then append the value returned from the function to the commentCount Div id
        var strID = event.target.id;
        strID = strID.replace("commentCount",
            "");
        //alert("strID is " + strID);
        jQuery.get(Drupal.settings.paragraph_comments.base_url + "/paragraph_comments_get_comment_count/" + strID,
            function (data) {
                jQuery("#commentCount" + strID).append("<p>" + data + " </p>")
            }, "json");
    }

});



/*

   //Global function that captures the paragraph text string when the "Submit Comment" button is clicked. 
   function captureString(event, paragraphText) {
      var strID2 = event.target.id;
      var response = ''; 
	         alert(event.target.id);
	document.getElementById(strID2).style.color="blue";
      var p2 = paragraphText; 
      var barP = p2.innerText; 
      barP.replace("\/\n/" + "gSubmit Comment",""); 
      var url = Drupal.settings.paragraph_comments.base_url + "/paragraph_comments_comment_form/" + Drupal.settings.paragraph_comments.nid + '/' + strID2 + '/' + Drupal.settings.paragraph_comments.current_content_type + '/' + barP; 

	var pageoffset = document.body.scrollTop;
	//window.location.hash = '#slidingDiv1453858';
        //onload='location.href="#myanchor2664687" '
        //window.location.href = url + '#myanchor2664687';
       // parent.bottom.location.href="bottom2.html
 
        console.log("here");
        

      return false;
   }
 
*/
